DATA_PATH = 'F:\data';

DATASET_NAME = 'Bird6\ORIG';

CONVNET_NAME = 'imagenet-vgg-verydeep-19';
CONVNET_FILENAME = [CONVNET_NAME, '.mat'];
for LAYER = [28, 30, 32, 34, 37, 39]
DESCRIPTOR1_NAME = fullfile(DATASET_NAME, [CONVNET_NAME, ',', num2str(LAYER), 'L']);
DESCRIPTOR2_NAME = fullfile(DATASET_NAME, [CONVNET_NAME, ',', num2str(LAYER + 2), 'L']);
GRADIENT_NAME = fullfile(DATASET_NAME, [CONVNET_NAME, ',', num2str(LAYER + 2), 'L']);
PYRAMID = [1, 1];
FEATURE_NAME = [DESCRIPTOR1_NAME, '_', num2str(size(PYRAMID, 1)), 'L'];

TIMES = 10;
TRAINING_SAMPLES_PER_CATEGORY = 50;
SPLIT_NAME = DATASET_NAME;
C = [10, 8, 12, 5, 20];
RESULT_FILE_NAME = ['T', num2str(TRAINING_SAMPLES_PER_CATEGORY), '_C'];
RESULT_FILE_EXPANSION = '.txt';
RESULT_NAME = FEATURE_NAME;

CONVNET_FILE = fullfile(DATA_PATH, 'convnets/PreTrained', CONVNET_FILENAME);
DATASET_PATH = fullfile(DATA_PATH, 'datasets', DATASET_NAME);
DESCRIPTOR1_PATH = fullfile(DATA_PATH, 'descriptors\Convnet_LFO_GRAD', DESCRIPTOR1_NAME);
DESCRIPTOR2_PATH = fullfile(DATA_PATH, 'descriptors\Convnet_LFO_GRAD', DESCRIPTOR2_NAME);
GRADIENT_PATH = fullfile(DATA_PATH, 'gradients\Convnet_LFO_GRAD', GRADIENT_NAME);
FEATURE_PATH = fullfile(DATA_PATH, 'features\Convnet_LFO_GRADS', FEATURE_NAME);
SPLIT_PATH = fullfile(DATA_PATH, 'splits\', SPLIT_NAME);
RESULT_PATH = fullfile(DATA_PATH, 'results\Convnet_LFO_GRADS', RESULT_NAME);

run(fullfile(DATA_PATH, 'libs', 'vlfeat/toolbox/vl_setup'));
run(fullfile(DATA_PATH, 'libs', 'matconvnet/matlab/vl_setupnn'));

going = true;

if (going)
    going = ExtractConvnet(CONVNET_FILE, DATASET_PATH, ...
        DESCRIPTOR1_PATH, DESCRIPTOR2_PATH, GRADIENT_PATH, FEATURE_PATH, LAYER, PYRAMID);
end
if (going)
    [accuracy, ~] = Classifier(FEATURE_PATH, SPLIT_PATH, RESULT_PATH, ...
        RESULT_FILE_NAME, RESULT_FILE_EXPANSION, TIMES, TRAINING_SAMPLES_PER_CATEGORY, C);
end
end

DATA_PATH = 'F:\data';

DATASET_NAME = 'Butterfly7\ORIG';

CONVNET_NAME = 'imagenet-vgg-verydeep-19';
CONVNET_FILENAME = [CONVNET_NAME, '.mat'];
for LAYER = [28, 30, 32, 34, 37, 39]
DESCRIPTOR1_NAME = fullfile(DATASET_NAME, [CONVNET_NAME, ',', num2str(LAYER), 'L']);
DESCRIPTOR2_NAME = fullfile(DATASET_NAME, [CONVNET_NAME, ',', num2str(LAYER + 2), 'L']);
GRADIENT_NAME = fullfile(DATASET_NAME, [CONVNET_NAME, ',', num2str(LAYER + 2), 'L']);
PYRAMID = [1, 1];
FEATURE_NAME = [DESCRIPTOR1_NAME, '_', num2str(size(PYRAMID, 1)), 'L'];

TIMES = 10;
TRAINING_SAMPLES_PER_CATEGORY = 26;
SPLIT_NAME = DATASET_NAME;
C = [10, 8, 12, 5, 20];
RESULT_FILE_NAME = ['T', num2str(TRAINING_SAMPLES_PER_CATEGORY), '_C'];
RESULT_FILE_EXPANSION = '.txt';
RESULT_NAME = FEATURE_NAME;

CONVNET_FILE = fullfile(DATA_PATH, 'convnets/PreTrained', CONVNET_FILENAME);
DATASET_PATH = fullfile(DATA_PATH, 'datasets', DATASET_NAME);
DESCRIPTOR1_PATH = fullfile(DATA_PATH, 'descriptors\Convnet_LFO_GRAD', DESCRIPTOR1_NAME);
DESCRIPTOR2_PATH = fullfile(DATA_PATH, 'descriptors\Convnet_LFO_GRAD', DESCRIPTOR2_NAME);
GRADIENT_PATH = fullfile(DATA_PATH, 'gradients\Convnet_LFO_GRAD', GRADIENT_NAME);
FEATURE_PATH = fullfile(DATA_PATH, 'features\Convnet_LFO_GRADS', FEATURE_NAME);
SPLIT_PATH = fullfile(DATA_PATH, 'splits\', SPLIT_NAME);
RESULT_PATH = fullfile(DATA_PATH, 'results\Convnet_LFO_GRADS', RESULT_NAME);

run(fullfile(DATA_PATH, 'libs', 'vlfeat/toolbox/vl_setup'));
run(fullfile(DATA_PATH, 'libs', 'matconvnet/matlab/vl_setupnn'));

going = true;

if (going)
    going = ExtractConvnet(CONVNET_FILE, DATASET_PATH, ...
        DESCRIPTOR1_PATH, DESCRIPTOR2_PATH, GRADIENT_PATH, FEATURE_PATH, LAYER, PYRAMID);
end
if (going)
    [accuracy, ~] = Classifier(FEATURE_PATH, SPLIT_PATH, RESULT_PATH, ...
        RESULT_FILE_NAME, RESULT_FILE_EXPANSION, TIMES, TRAINING_SAMPLES_PER_CATEGORY, C);
end
end

DATA_PATH = 'F:\data';

DATASET_NAME = 'Flower17\ORIG';

CONVNET_NAME = 'imagenet-vgg-verydeep-19';
CONVNET_FILENAME = [CONVNET_NAME, '.mat'];
for LAYER = [28, 30, 32, 34, 37, 39]
DESCRIPTOR1_NAME = fullfile(DATASET_NAME, [CONVNET_NAME, ',', num2str(LAYER), 'L']);
DESCRIPTOR2_NAME = fullfile(DATASET_NAME, [CONVNET_NAME, ',', num2str(LAYER + 2), 'L']);
GRADIENT_NAME = fullfile(DATASET_NAME, [CONVNET_NAME, ',', num2str(LAYER + 2), 'L']);
PYRAMID = [1, 1];
FEATURE_NAME = [DESCRIPTOR1_NAME, '_', num2str(size(PYRAMID, 1)), 'L'];

TIMES = 10;
TRAINING_SAMPLES_PER_CATEGORY = 60;
SPLIT_NAME = DATASET_NAME;
C = [10, 8, 12, 5, 20];
RESULT_FILE_NAME = ['T', num2str(TRAINING_SAMPLES_PER_CATEGORY), '_C'];
RESULT_FILE_EXPANSION = '.txt';
RESULT_NAME = FEATURE_NAME;

CONVNET_FILE = fullfile(DATA_PATH, 'convnets/PreTrained', CONVNET_FILENAME);
DATASET_PATH = fullfile(DATA_PATH, 'datasets', DATASET_NAME);
DESCRIPTOR1_PATH = fullfile(DATA_PATH, 'descriptors\Convnet_LFO_GRAD', DESCRIPTOR1_NAME);
DESCRIPTOR2_PATH = fullfile(DATA_PATH, 'descriptors\Convnet_LFO_GRAD', DESCRIPTOR2_NAME);
GRADIENT_PATH = fullfile(DATA_PATH, 'gradients\Convnet_LFO_GRAD', GRADIENT_NAME);
FEATURE_PATH = fullfile(DATA_PATH, 'features\Convnet_LFO_GRADS', FEATURE_NAME);
SPLIT_PATH = fullfile(DATA_PATH, 'splits\', SPLIT_NAME);
RESULT_PATH = fullfile(DATA_PATH, 'results\Convnet_LFO_GRADS', RESULT_NAME);

run(fullfile(DATA_PATH, 'libs', 'vlfeat/toolbox/vl_setup'));
run(fullfile(DATA_PATH, 'libs', 'matconvnet/matlab/vl_setupnn'));

going = true;

if (going)
    going = ExtractConvnet(CONVNET_FILE, DATASET_PATH, ...
        DESCRIPTOR1_PATH, DESCRIPTOR2_PATH, GRADIENT_PATH, FEATURE_PATH, LAYER, PYRAMID);
end
if (going)
    [accuracy, ~] = Classifier(FEATURE_PATH, SPLIT_PATH, RESULT_PATH, ...
        RESULT_FILE_NAME, RESULT_FILE_EXPANSION, TIMES, TRAINING_SAMPLES_PER_CATEGORY, C);
end
end

DATA_PATH = 'F:\data';

DATASET_NAME = 'Caltech101\ORIG';

CONVNET_NAME = 'imagenet-vgg-verydeep-19';
CONVNET_FILENAME = [CONVNET_NAME, '.mat'];
for LAYER = [28, 30, 32, 34, 37, 39]
DESCRIPTOR1_NAME = fullfile(DATASET_NAME, [CONVNET_NAME, ',', num2str(LAYER), 'L']);
DESCRIPTOR2_NAME = fullfile(DATASET_NAME, [CONVNET_NAME, ',', num2str(LAYER + 2), 'L']);
GRADIENT_NAME = fullfile(DATASET_NAME, [CONVNET_NAME, ',', num2str(LAYER + 2), 'L']);
PYRAMID = [1, 1];
FEATURE_NAME = [DESCRIPTOR1_NAME, '_', num2str(size(PYRAMID, 1)), 'L'];

TIMES = 10;
TRAINING_SAMPLES_PER_CATEGORY = 30;
SPLIT_NAME = DATASET_NAME;
C = [10, 8, 12, 5, 20];
RESULT_FILE_NAME = ['T', num2str(TRAINING_SAMPLES_PER_CATEGORY), '_C'];
RESULT_FILE_EXPANSION = '.txt';
RESULT_NAME = FEATURE_NAME;

CONVNET_FILE = fullfile(DATA_PATH, 'convnets/PreTrained', CONVNET_FILENAME);
DATASET_PATH = fullfile(DATA_PATH, 'datasets', DATASET_NAME);
DESCRIPTOR1_PATH = fullfile(DATA_PATH, 'descriptors\Convnet_LFO_GRAD', DESCRIPTOR1_NAME);
DESCRIPTOR2_PATH = fullfile(DATA_PATH, 'descriptors\Convnet_LFO_GRAD', DESCRIPTOR2_NAME);
GRADIENT_PATH = fullfile(DATA_PATH, 'gradients\Convnet_LFO_GRAD', GRADIENT_NAME);
FEATURE_PATH = fullfile(DATA_PATH, 'features\Convnet_LFO_GRADS', FEATURE_NAME);
SPLIT_PATH = fullfile(DATA_PATH, 'splits\', SPLIT_NAME);
RESULT_PATH = fullfile(DATA_PATH, 'results\Convnet_LFO_GRADS', RESULT_NAME);

run(fullfile(DATA_PATH, 'libs', 'vlfeat/toolbox/vl_setup'));
run(fullfile(DATA_PATH, 'libs', 'matconvnet/matlab/vl_setupnn'));

going = true;

if (going)
    going = ExtractConvnet(CONVNET_FILE, DATASET_PATH, ...
        DESCRIPTOR1_PATH, DESCRIPTOR2_PATH, GRADIENT_PATH, FEATURE_PATH, LAYER, PYRAMID);
end
if (going)
    [accuracy, ~] = Classifier(FEATURE_PATH, SPLIT_PATH, RESULT_PATH, ...
        RESULT_FILE_NAME, RESULT_FILE_EXPANSION, TIMES, TRAINING_SAMPLES_PER_CATEGORY, C);
end
end

DATA_PATH = 'F:\data';

DATASET_NAME = 'Pet37\ORIG';

CONVNET_NAME = 'imagenet-vgg-verydeep-19';
CONVNET_FILENAME = [CONVNET_NAME, '.mat'];
for LAYER = [28, 30, 32, 34, 37, 39]
DESCRIPTOR1_NAME = fullfile(DATASET_NAME, [CONVNET_NAME, ',', num2str(LAYER), 'L']);
DESCRIPTOR2_NAME = fullfile(DATASET_NAME, [CONVNET_NAME, ',', num2str(LAYER + 2), 'L']);
GRADIENT_NAME = fullfile(DATASET_NAME, [CONVNET_NAME, ',', num2str(LAYER + 2), 'L']);
PYRAMID = [1, 1];
FEATURE_NAME = [DESCRIPTOR1_NAME, '_', num2str(size(PYRAMID, 1)), 'L'];

TIMES = 10;
TRAINING_SAMPLES_PER_CATEGORY = 100;
SPLIT_NAME = DATASET_NAME;
C = [10, 8, 12, 5, 20];
RESULT_FILE_NAME = ['T', num2str(TRAINING_SAMPLES_PER_CATEGORY), '_C'];
RESULT_FILE_EXPANSION = '.txt';
RESULT_NAME = FEATURE_NAME;

CONVNET_FILE = fullfile(DATA_PATH, 'convnets/PreTrained', CONVNET_FILENAME);
DATASET_PATH = fullfile(DATA_PATH, 'datasets', DATASET_NAME);
DESCRIPTOR1_PATH = fullfile(DATA_PATH, 'descriptors\Convnet_LFO_GRAD', DESCRIPTOR1_NAME);
DESCRIPTOR2_PATH = fullfile(DATA_PATH, 'descriptors\Convnet_LFO_GRAD', DESCRIPTOR2_NAME);
GRADIENT_PATH = fullfile(DATA_PATH, 'gradients\Convnet_LFO_GRAD', GRADIENT_NAME);
FEATURE_PATH = fullfile(DATA_PATH, 'features\Convnet_LFO_GRADS', FEATURE_NAME);
SPLIT_PATH = fullfile(DATA_PATH, 'splits\', SPLIT_NAME);
RESULT_PATH = fullfile(DATA_PATH, 'results\Convnet_LFO_GRADS', RESULT_NAME);

run(fullfile(DATA_PATH, 'libs', 'vlfeat/toolbox/vl_setup'));
run(fullfile(DATA_PATH, 'libs', 'matconvnet/matlab/vl_setupnn'));

going = true;

if (going)
    going = ExtractConvnet(CONVNET_FILE, DATASET_PATH, ...
        DESCRIPTOR1_PATH, DESCRIPTOR2_PATH, GRADIENT_PATH, FEATURE_PATH, LAYER, PYRAMID);
end
if (going)
    [accuracy, ~] = Classifier(FEATURE_PATH, SPLIT_PATH, RESULT_PATH, ...
        RESULT_FILE_NAME, RESULT_FILE_EXPANSION, TIMES, TRAINING_SAMPLES_PER_CATEGORY, C);
end
end

DATA_PATH = 'F:\data';

DATASET_NAME = 'Flower102\ORIG';

CONVNET_NAME = 'imagenet-vgg-verydeep-19';
CONVNET_FILENAME = [CONVNET_NAME, '.mat'];
for LAYER = [28, 30, 32, 34, 37, 39]
DESCRIPTOR1_NAME = fullfile(DATASET_NAME, [CONVNET_NAME, ',', num2str(LAYER), 'L']);
DESCRIPTOR2_NAME = fullfile(DATASET_NAME, [CONVNET_NAME, ',', num2str(LAYER + 2), 'L']);
GRADIENT_NAME = fullfile(DATASET_NAME, [CONVNET_NAME, ',', num2str(LAYER + 2), 'L']);
PYRAMID = [1, 1];
FEATURE_NAME = [DESCRIPTOR1_NAME, '_', num2str(size(PYRAMID, 1)), 'L'];

TIMES = 10;
TRAINING_SAMPLES_PER_CATEGORY = 20;
SPLIT_NAME = DATASET_NAME;
C = [10, 8, 12, 5, 20];
RESULT_FILE_NAME = ['T', num2str(TRAINING_SAMPLES_PER_CATEGORY), '_C'];
RESULT_FILE_EXPANSION = '.txt';
RESULT_NAME = FEATURE_NAME;

CONVNET_FILE = fullfile(DATA_PATH, 'convnets/PreTrained', CONVNET_FILENAME);
DATASET_PATH = fullfile(DATA_PATH, 'datasets', DATASET_NAME);
DESCRIPTOR1_PATH = fullfile(DATA_PATH, 'descriptors\Convnet_LFO_GRAD', DESCRIPTOR1_NAME);
DESCRIPTOR2_PATH = fullfile(DATA_PATH, 'descriptors\Convnet_LFO_GRAD', DESCRIPTOR2_NAME);
GRADIENT_PATH = fullfile(DATA_PATH, 'gradients\Convnet_LFO_GRAD', GRADIENT_NAME);
FEATURE_PATH = fullfile(DATA_PATH, 'features\Convnet_LFO_GRADS', FEATURE_NAME);
SPLIT_PATH = fullfile(DATA_PATH, 'splits\', SPLIT_NAME);
RESULT_PATH = fullfile(DATA_PATH, 'results\Convnet_LFO_GRADS', RESULT_NAME);

run(fullfile(DATA_PATH, 'libs', 'vlfeat/toolbox/vl_setup'));
run(fullfile(DATA_PATH, 'libs', 'matconvnet/matlab/vl_setupnn'));

going = true;

if (going)
    going = ExtractConvnet(CONVNET_FILE, DATASET_PATH, ...
        DESCRIPTOR1_PATH, DESCRIPTOR2_PATH, GRADIENT_PATH, FEATURE_PATH, LAYER, PYRAMID);
end
if (going)
    [accuracy, ~] = Classifier(FEATURE_PATH, SPLIT_PATH, RESULT_PATH, ...
        RESULT_FILE_NAME, RESULT_FILE_EXPANSION, TIMES, TRAINING_SAMPLES_PER_CATEGORY, C);
end
end
